/*
* Template-File src/main/takatuka/templates/EntityAbstractSearch.vm
*/
package de.ivu.elect.business.entschaedigung.boundary;

import java.util.List;

import javax.inject.Inject;

import de.ivu.elect.business.entschaedigung.entity.Entschaedigung;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.jee.presentation.search.WildcardConverter;

public abstract class AbstractEntschaedigungSearch {

  @Inject
  protected transient EntschaedigungExtendedDAO dao;

  public AbstractEntschaedigungSearch() {
    super();
  }

  public List<Entschaedigung> getSearchResult(EntschaedigungSearchParameters searchParameters, EagerLoadingCollector<Entschaedigung> eagerLoadingCollector) {
    return eagerLoadingCollector.eagerLoad(querySearchResult(searchParameters));
  }

  protected abstract List<Entschaedigung> querySearchResult(EntschaedigungSearchParameters searchParameters);

  protected String convertSearchPattern(String patternInput) {
    return new WildcardConverter().addAndConvertToJpqlLikeExpression(patternInput);
  }
}
